/*
TASK: table
LANG: C++
*/

#include <iostream>
#include <cstdio>

using namespace std;

const int MOD=333333;

int n,m,to,res=0,tmp;
int T[35][35],S[35][35];

int f(const int &i,const int &j)
{ return (i<0 || i>=n || j<0 || j>=m)?0:S[i][j]; }

int s(const int &i,const int &j)
{ return ( f(i-1,j)+f(i+1,j)+f(i,j-1)+f(i,j+1) ); }

bool check()
{
 int i,j;
 for(i=0;i<n;i++)
     for(j=0;j<m;j++)
         {
          tmp=s(i,j);
          if((tmp%3)!=T[i][j]) return 0;   
         }        
 
 return 1;
}

void gen(int pos)
{
 if(pos==to) { if(check()) { res++; 
                             res%=MOD;
                           }
               return;
             }
 int i=pos/m,j=pos%m;
 
 S[i][j]=0;
 if(pos>=m) { tmp=s(i-1,j);
              if((tmp%3)==T[i-1][j]) gen(pos+1);
             }
 else gen(pos+1);
 
 S[i][j]=1;
 if(pos>=m) { tmp=s(i-1,j);
              if((tmp%3)==T[i-1][j]) gen(pos+1);
             }
 else gen(pos+1);
             
 S[i][j]=2;
 if(pos>=m) { tmp=s(i-1,j);
              if((tmp%3)==T[i-1][j]) gen(pos+1);
             }     
 else gen(pos+1);
}

int main()
{int i,j;
 scanf("%d %d",&n,&m);
 for(i=0;i<n;i++)
    for(j=0;j<m;j++)
        scanf("%d",&T[i][j]);
 
 to=n*m;
 gen(0); 
 
 printf("%d\n",res);

 return 0;
}
