/*
TASK:string
LANG:C++
*/
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <queue>
#include <algorithm>
#include <utility>
#include <numeric>
#include <functional>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define PI pair<int,int>
#define PD pair<double,double>
#define VI vector<int>
#define VD vector<double>
#define LL long long
#define PB push_back
#define MP make_pair
#define SZ size()
#define ALL(v) (v).begin(),(v).end()
#define x first
#define y second
#define ULL unsigned LL
#define ABS(x) (((x)>0)?(x):(-(x)))
#define sign(x) (((x)>0)-((x)<0))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define PQ priority_queue

#define Time (double)clock()/CLOCKS_PER_SEC
#define pause system("pause")

#define MAXN 1000005

int N,M;
char s[MAXN];
int suff[MAXN],suffp[MAXN];

inline bool simple(int st,int en)
{
     for (int i=st+1;i<en;i++)
      if (strncmp(s+st,s+i,en-i)!=-1) return 0;
     return 1;
}

inline bool sux(int s1,int e1,int e2)
{
     int len1=e1-s1,len2=e2-e1;
     int ret=strncmp(s+s1,s+e1, min(len1,len2) );
     return (ret!=0)?(ret<0):len1<len2;
 }

void write(int st,int en)
{
    for (int j=st;j<en;j++) cout<<s[j];
 }

int end[MAXN];
void brute(int pos)
{
     if (end[pos-1]==N)
      {
                        /* Repi(end[0]) cout<<s[i]; cout<<endl;
                         for (int i=1;i<pos;i++)
                          {
                            for (int j=end[i-1];j<end[i];j++)
                              cout<<s[j];
                            cout<<endl;
                          }*/
                         printf("%d ",pos-1); 
                         for (int i=1;i<pos;i++) 
                          {printf("%d",end[i]-end[i-1]);
                           if (i==pos-1) printf("\n"); else printf(" ");
                          }
                        // cout<<Time<<endl;
                         exit(0);
      }
//     bool allequal=1;
     for (end[pos]=end[pos-1]+1;end[pos]<=N;end[pos]++)
      {
        // if (end[pos]!=end[pos-1]+1 && s[end[pos]-1]!=s[end[pos]-2]) allequal=0;
         
         //if (allequal && end[pos]!=end[pos-1]+1) continue;
         //if (suffp[end[pos-1]]>suffp[end[pos]-1]) return;
         
         //if (!simple(end[pos-1],end[pos])) continue; - -sux & slow
         //if (pos>1 && sux(end[pos-2],end[pos-1],end[pos])) continue;
         //if (sux(end[pos-1],end[pos],N)) continue;
         
         if (suffp[end[pos-1]]<suffp[end[pos]]) continue;
         
         //cout<<"          set "<<pos<<" = "; write(end[pos-1],end[pos]); cout<<"   "<<end[pos]-end[pos-1]<<" "<<end[pos-1]-end[pos-2]<<" ; "<<strncmp( s+end[pos-2], s+end[pos-1] , min(end[pos]-end[pos-1],end[pos-1]-end[pos-2]) )<<endl;
         brute(pos+1);
      }
}




bool scmp(int a,int b)
{
    // cout<<s+a<<" "<<s+b<<" = "<<strcmp(s+a,s+b)<<endl;
          return strcmp(s+a,s+b)<0; }

void suffixarray()
{
     Repi(N) suff[i]=i;
     sort(suff,suff+N,scmp);
     Repi(N) suffp[suff[i]]=i;
     //Repi(N) cout<<s+suff[i]<<endl;
    // Repi(N) cout<<s[i]<<" "<<suffp[i]<<"\n";
}

int main()
{
    //freopen("string.in","r",stdin); 
    //freopen("string.out","w",stdout);
    scanf("%s",s);
    //strcpy(s,"baaaaazzaaaaaaaabbbzzzzazabbb");
    N=strlen(s); s[N]=0;
    //cout<<s<<" "<<N<<endl;
    
    suffixarray();
    //cout<<Time<<endl;
    
    end[0]=0;
    brute(1);
    //pause;
    return 0;
}
