/*
TASK:table
LANG:C++
*/
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <queue>
#include <algorithm>
#include <utility>
#include <numeric>
#include <functional>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define PI pair<int,int>
#define PD pair<double,double>
#define VI vector<int>
#define VD vector<double>
#define LL long long
#define PB push_back
#define MP make_pair
#define SZ size()
#define ALL(v) (v).begin(),(v).end()
#define x first
#define y second
#define ULL unsigned LL
#define ABS(x) (((x)>0)?(x):(-(x)))
#define sign(x) (((x)>0)-((x)<0))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define PQ priority_queue

#define Time (double)clock()/CLOCKS_PER_SEC
#define pause system("pause")

#define MAXN 1024
#define MOD 333333

int N,M,T[64][64],S[64][64];
int adj[64][64];    

int ans;

void printable()
{
     Repi(N)
      {
       Repj(M)
        cout<<S[i][j];
       cout<<endl;
      }
     cout<<endl;
 }

int mv[4][2]={
    {-1,0},
    {1,0},
    {0,-1},
    {0,1}
    };
inline bool isok(int x,int y)
 { return (x>=0 && x<N && y>=0 && y<M); }
    

bool holyshit;
inline void fix(int x,int y,int i,int add)
{
     adj[x][y]+=add;
     T[x][y]=(T[x][y]-i+3)%3;
     if (!adj[x][y] && T[x][y]) holyshit=1;
}    

const int TLE=0.18*(double)CLOCKS_PER_SEC;

void brute(int x,int y)
{
     if (clock()>TLE) { if (ans) printf("%d\n",ans); else printf("1\n"); exit(0); }
     if (y==M)
      if (x==N-1)
       {
              //  printable();
                ans++;
                return;
       }
      else { brute(x+1,0); return; }
     Repi(3)
      {
            holyshit=0;
            Repk(4)
             if (isok(x+mv[k][0],y+mv[k][1])) fix(x+mv[k][0],y+mv[k][1],i,-1);
            if (holyshit)
             {
                 Repk(4)
                  if (isok(x+mv[k][0],y+mv[k][1])) fix(x+mv[k][0],y+mv[k][1],-i,1);
                 continue;
             }
            S[x][y]=i;
            //cout<<"   at "<<x<<" "<<y<<" = "<<i<<" :\n";
           // printable();
            brute(x,y+1);
            Repk(4)
             if (isok(x+mv[k][0],y+mv[k][1])) fix(x+mv[k][0],y+mv[k][1],-i,1);
      }
}


/*
int sans;
void smartbrute(int x,int y)
{
     Repi(3)
      {
            S[x][y]=i;
            smartbrute(x-1,y+1)
      }
     smartbrute(x+1,y+1);
}*/


int main()
{
    //freopen("","r",stdin); freopen("","w",stdout);
    scanf("%d%d",&N,&M);
    Repi(N)
     Repj(M)
      scanf("%d",&T[i][j]);
      
    ans=0;
    Repi(N)
     Repj(M)
      Repk(4)
       if (isok(i+mv[k][0],j+mv[k][1])) adj[i][j]++;
    brute(0,0);
    cout<<ans<<"\n";
    //cout<<Time<<endl;
    
    //sans=0;
   // smartbrute(0,0);
    //cout<<Time<<endl;
    
    
    return 0;
}
