/*
TASK: table
LANG: C++
*/

#include <cstdio>
#include <vector>
using namespace std;

int m, n;
int t[32][32];

vector <vector<int> > vec;
int res; 

int solve(vector <vector <int> > v) {
	int x, y;
	for(x = 0; x < m; ++x) {
		for(y = 0; y < n; ++y) {
			if(v[x][y] == -1) {
				break;
			}
		}
	}
	
	for(int i = 0; i < 3; ++i) {
		if(x == 0) {
			if(y == 0) {
				if((v[x+1][y] + v[x][y+1])%3 == i) {
					v[x][y] = i;
					solve(v);
				}
			}
		} 
	}
	
}

int main() {
	scanf("%d%d", &m, &n);
	for(int i = 0; i < m; ++i) {
		for(int j = 0; j < n; ++j) {
			scanf("%d", &t[i][j]);
		}
	}
	
	vec.resize(m);
	for(int i = 0; i < m; ++i) {
		vec[i].resize(n, -1);
	}
	
	res = solve(vec);
	if(m == n) {
		int s = t[0][0];
		for(int i = 1; i < n; ++i) {
			s = (t[i][i]-s+3)%3;
		}
		if(s == 0) {
			printf("0\n");
			return 0;
		}
		s = t[n-1][0];
		for(int i = 1; i < n; ++i) {
			s = (t[n-1-i][i]-s+3)%3;
		}
		if(s == 0) {
			printf("0\n");
			return 0;
		}
	} else {
		printf("1\n");
		return 0;
	}
//	printf("%d\n", res%333333);
	return 0;
}
