/*
TASK: table
LANG: C++
*/
#include <iostream>
using namespace std;

int G[32*33][32*33];
int mul[3][3] = { 0,  -1, -1,
                 -1,   2,  1, 
                 -1,   1,  2 }; 
int N, M;
int T[32][32];

void swapp(int i1, int i2)
{
     for (int j = 0; j <= N*M + 1; j++) swap(G[i1][j], G[i2][j]);
}

bool zeros(int i1)
{
     for (int j = 0; j < N*M; j++) if (G[i1][j] != 0) return 0;
     return 1;
}

bool eqq(int i1, int i2)
{
     for (int j = 0; j < N*M; j++) if (G[i1][j] != G[i2][j]) return 0;
     return 1;
}
int main()
{
    cin >> N >> M;
    for (int i = 0; i < N; i++) for (int j = 0; j < M; j++)
     //T[i][j] = 0;
     cin >> T[i][j];
   // for (N = 1; N <= 32; N++) for (M = 1; M <= 32; M++)
    
    //    memset(G, 0, sizeof(G));
    
    for (int k = 0; k < N*M; k++) 
    {
        int i = k/M, j = k%M;     
        if (i - 1 >= 0) G[k][k - M] = 1;
        if (j - 1 >= 0) G[k][k - 1] = 1;
        if (i + 1 <  N) G[k][k + M] = 1;
        if (j + 1 <  M) G[k][k + 1] = 1;
        G[k][N*M] = T[i][j];
        G[k][N*M + 1] = k;
    }
    /*
    for (int i = 0; i < N*M; i++)
    {
        for (int j = 0; j <= N*M; j++)
         cout << G[i][j] << " ";
        cout << endl;
    }
    */
    int ans = 1;
    for (int i = 0; i < N*M; i++)
    {
        bool flag = 1;
        if (G[i][i] == 0)
        {
              flag = 0;
              for (int i2 = i + 1; i2 < N*M; i2++) 
               if (G[i2][i] != 0)
               {
                    swapp(i, i2);
                    flag = 1;
                    break;
               }
        }
        if (flag == 0) { ans = (ans*3)%333333; continue; }
        
        
        for (int i1 = i + 1; i1 < N*M; i1++) if (G[i1][i] != 0)
        {
            int m = mul[ G[i][i] ][ G[i1][i] ];
            for (int j = i; j <= N*M; j++)
             G[i1][j] = (G[i][j]*m + G[i1][j])%3;
        }
     //   system("pause");
    }
    /*
    for (int i = 0; i < N*M; i++)
    {
        for (int j = 0; j <= N*M + 1; j++)
         cout << G[i][j] << " ";
        cout << endl;
    }
    */
    for (int i = 0; i < N*M; i++) if (zeros(i))
     if (G[i][N*M] != 0) {cout << 0 << endl; return 0; }
    // if (eqq(i, j)) cout << "ss" << endl;
    
    
    cout << ans << endl;
    return 0;
}
