
/*
TASK: string
LANG: C++
*/

#include <cassert>
#include <string>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const int MAXN = 4096;

int N;
string str;
bool is[MAXN][MAXN];
bool can[MAXN][MAXN];

inline int compare(string &a, string &b, int ba, int lena, int bb, int lenb)
{
    for (int j = 0; j < min(lena, lenb); ++j)
        if (a[ba + j] < b[bb + j])
            return -1;
        else if (a[ba + j] > b[bb + j])
            return 1;
    if (lena == lenb)
        return 0;
    if (lena < lenb)
        return -1;
    return 1;
}

int main()
{
    cin >> str;
    N = (int) str.size();
    
    if (N < 1000)
    {
    
    for (int i = 0; i < N; ++i)
        for (int j = 1; i + j <= N; ++j)
        {
//            string z = str.substr(i, j);
            is[i][j] = true;
            for (int k = 1; k < j; ++k)
//                if (z >= str.substr(i + j - k, k))
                if (compare(str, str, i, j, i + j - k, k) >= 0)
                {
                    is[i][j] = false;
                    break;
                }
        }
    
    for (int i = 1; i <= N; ++i)
        if (is[0][i])
            can[0][i] = true;
    for (int i = 1; i < N; ++i)
        for (int j = 1; i - j >= 0; ++j)
            if (can[i - j][i])
            {
//                string z = str.substr(i - j, j);
                for (int k = 1; i + k <= N; ++k)
//                    if (is[i][k] && str.substr(i, k) <= z)
                    if (is[i][k] && compare(str, str, i, k, i - j, j) <= 0)
                        can[i][i + k] = true;
            }
    
    int len = -1;
    int end = N;
    int u = 0;
    for (int i = 1; i <= N; ++i)
        if (can[N - i][N])
        {
            ++u;
            len = i;
        }
    assert(u == 1);
    assert(len >= 1);
    vector <int> res;
    while (true)
    {
//        printf("%d\n", len);
        res.push_back(len);
        end -= len;
        if (end == 0)
            break;
        len = -1;
        int k = 0;
        for (int z = 1; z <= end; ++z)
            if (can[end - z][end])
            {
                ++k;
                len = z;
//                break;
            }
//        printf("%d ", k);
        assert(len >= 1);
    }
//    puts("");
    
    printf("%d", (int) res.size());
    for (int j = (int) res.size() - 1; j >= 0; --j)
        printf(" %d", res[j]);
    puts("");
    }
    else
    {
        vector <int> all;
    
    string s = str;
    int n = (int) s.size();
    
    int p = 0;
    int len = 0;
    while (true)
    {
        for (int j = n - p; j >= 1; --j)
        {
            string x = s.substr(p, j);
            bool ok = true;
            for (int k = 1; k < j; ++k)
                if (compare(s, s, p, j, p + j - k, k) >= 0)
                {
                    ok = false;
                    break;
                }
            if (ok && (p == 0 || compare(s, s, p - len, len, p, j) >= 0))
            {
                len = j;
                all.push_back(j);
                p += j;
                break;
            }
        }
        if (p == n)
            break;
    }
    
    printf("%d", (int)all.size());
    for (int i = 0; i < (int) all.size(); ++i)
        printf(" %d", all[i]);
    puts("");
    }
    return 0;
}
