/*
TASK: table
LANG: C++
*/
#include <cstdio>
#include <cstdlib>
#include <cstring>

using namespace std;

const int maxN = 36;
int d[maxN][maxN], v[maxN][maxN];
int b[maxN];
int m, n;
int res = 0;

void check(){
  int i, j;
  memset(v, 0, sizeof(v));
  for(j = 1; j <= n; j++) v[1][j] = b[j];
  
  for(i = 2; i <= m; i++)
  for(j = 1; j <= n; j++)
  v[i][j] = (9 + d[i][j] - v[i-1][j-1] - v[i-1][j+1] - v[i-2][j]) % 3;    
  
  for(j = 1; j < n; j++)
  if(d[m][j] != (v[m][j-1] + v[m][j+1] + v[m-1][j] )% 3) return;
  
  res += 1;
  res %= 333333;
}

void rec(int i){
    if(i == n){
      b[n] = 0;
      check();
      b[n] = 1;
      check();
      b[n] = 2;
      check();    
    }else{
      b[i] = 0;
      rec(i+1);
      b[i] = 1;
      rec(i+1);
      b[i] = 2;
      rec(i+1);    
    }
}

int main(){
    int i, j;
    scanf("%d%d", &m, &n);
    for(i = 1; i <= m; i++)
    for(j = 1; j <= n; j++)
    scanf("%d", &d[i][j]);
    
    memset(b, 0, sizeof(b));
    
    rec(1);
    printf("%d\n", res);
    
    return 0;
}
