/*
TASK:mirrors
LANG:C++
*/

#include<cstdio>
#include<cmath>

struct pnt{double x,y;pnt(){}pnt(double _x,double _y){x=_x;y=_y;}};

pnt A,B;
pnt mir[16][2];
int n;

bool pl=0;
double ccw(pnt p0,pnt p1,pnt p2) {return (p1.x-p0.x)*(p2.y-p0.y)-(p2.x-p0.x)*(p1.y-p0.y);}
bool intersect(pnt a1,pnt a2,pnt b1,pnt b2, pnt & p) {
	double d1=ccw(a1,a2,b1),
		   d2=ccw(a1,a2,b2),
		   d3=ccw(b1,b2,a1),
		   d4=ccw(b1,b2,a2);
	if(fabs(d3)<0.000001&&fabs(d4)<0.000001) {pl=1;return 1;}	   
	if( d1*d2<0 && d3*d4<0) {
		if(d1<0) d1=-d1;
		if(d2<0) d2=-d2;
		p.x=b1.x+(b2.x-b1.x)*d1/(d1+d2);
		p.y=b1.y+(b2.y-b1.y)*d1/(d1+d2);
		return 1;
	}
	
	return 0;
}

int otr[16];

void ch_ang(pnt a, pnt b, pnt p, pnt n, double & n_ang) {
	double lab=sqrt((b.x-a.x)*(b.x-a.x)+(b.y-a.y)*(b.y-a.y));

	double scal=(b.x-a.x)*(n.x-p.x)+(b.y-a.y)*(n.y-p.y);
	double vtl=scal/lab;
	double vtx=(b.x-a.x)/lab*vtl,vty=(b.y-a.y)/lab*vtl;
	double vnx=-((n.x-p.x)-vtx),vny=-((n.y-p.y)-vty);
	n_ang=atan2(vty+vny,vtx+vnx);
}

int main() {
	scanf("%d",&n);
	scanf("%lf%lf%lf%lf",&A.x,&A.y,&B.x,&B.y);
	for(int i=0;i<n;++i) scanf("%lf%lf%lf%lf",&mir[i][0].x,&mir[i][0].y,&mir[i][1].x,&mir[i][1].y);
	
	pnt p=A,np;
	double angle;
	int ans,clm;
	double mind,d;
	int br_otr;
	bool has_ans=0;
	double grad,mindistb;
	
	mindistb=200000001;has_ans=0;
	for(int i=0;i<360;++i) {
		p=A;
		br_otr=0;
		angle=(double)i*M_PI/180;
		while(1) {
			clm=-1;mind=200000001;
			for(int j=0;j<n;++j) {
				if(otr[j]==i) continue;
				d=ccw(mir[j][0],mir[j][1],p);
				if(d>0&&d<mind) {
					if(intersect(mir[j][0],mir[j][1],p,pnt(p.x+cos(angle)*20000,p.y+sin(angle)*20000),np)) {
						mind=d;
						clm=j;
					}
				}
			}
			
			if(clm!=-1) {
				otr[clm]=i;
				if(pl==0) {
				ch_ang(mir[clm][0],mir[clm][1],p,np,angle);
				p=np;
				} else pl=0;
				++br_otr;
			}
			else {
				break;
			}
	
		}
		
		if(br_otr==n) {
			np.x=p.x+cos(angle)*25;
			np.y=p.y+sin(angle)*25;
			double distb=ccw(p,np,B);
			if(distb<0)distb=-distb;
			if(distb<mindistb) {mindistb=distb;grad=i;}
		}
		
	}
int gr;
for(int k=1;k<=2;++k) {
	mindistb=200000001;
	for(int i=0;i<10;++i) {
		p=A;
		br_otr=0;
		angle=(grad+pow(0.1,k)*i)*M_PI/180.0;
		while(1) {
			clm=-1;mind=200000001;
			for(int j=0;j<n;++j) {
				if(otr[j]==i) continue;
				d=ccw(mir[j][0],mir[j][1],p);
				if(d>0&&d<mind) {
					if(intersect(mir[j][0],mir[j][1],p,pnt(p.x+cos(angle)*20000,p.y+sin(angle)*20000),np)) {
						mind=d;
						clm=j;
					}
				}
			}
			
			if(clm!=-1) {
				otr[clm]=i;
				if(pl==0) {
				ch_ang(mir[clm][0],mir[clm][1],p,np,angle);
				p=np;
				} else pl=0;
				++br_otr;
			}
			else {
				break;
			}
	
		}
		
		if(br_otr==n) {
			np.x=p.x+cos(angle)*25;
			np.y=p.y+sin(angle)*25;
			double distb=ccw(p,np,B);
			if(distb<0)distb=-distb;
			if(distb<mindistb) {mindistb=distb;gr=i;}
		}
		
	}
	grad=grad+pow(0.1,k)*gr;
}

	mindistb=200000001;
	int minii=0;
	for(int i=0;i<10000;++i) {
		p=A;
		br_otr=0;
		angle=(grad+(double)i/1000000.0)*M_PI/180.0;
		while(1) {
			clm=-1;mind=200000001;
			for(int j=0;j<n;++j) {
				if(otr[j]==i) continue;
				d=ccw(mir[j][0],mir[j][1],p);
				if(d>0&&d<mind) {
					if(intersect(mir[j][0],mir[j][1],p,pnt(p.x+cos(angle)*20000,p.y+sin(angle)*20000),np)) {
						mind=d;
						clm=j;
					}
				}
			}
			
			if(clm!=-1) {
				otr[clm]=i;
				if(pl==0) {
				ch_ang(mir[clm][0],mir[clm][1],p,np,angle);
				p=np;
				} else pl=0;
				++br_otr;
			}
			else {
				break;
			}
	
		}
		
		if(br_otr==n) {
			np.x=p.x+cos(angle)*25;
			np.y=p.y+sin(angle)*25;
			double distb=ccw(p,np,B);
			if(distb<0)distb=-distb;
			if(distb<mindistb) {mindistb=distb;minii=i;}
		}
		
	}
	grad+=(double)minii/1000000.0;
	if(mindistb<0.000001) {
		printf("YES\n");
		printf("%.6lf\n",grad);
	} else {
		printf("NO");
	}
	return 0;
}
